#include <GL/glut.h> //glut library, it imports gl.h, glu.h
#include <stdlib.h> //for exit call

void drawTriangle()
{
	/* sets color to red */
	glColor3f(1.0,0.0,0.0);
	/* glBegin composes the group of vertices below as a
	   polygon */
	glBegin(GL_POLYGON);
		glVertex3f(0.0, -10.0, -6.0); //x = 0, y = -10, z = -6
		glVertex3f(-10.0, 0.0, 6.0); //x = -10, y = 0, z = 6
		glVertex3f(10.0, 0.0, 6.0); //x = 10, y = 0, z = 6z
	/* glEnd indicates the end of the rendering group */
	glEnd();
}

void constructTriangles()
{
	/* -90 degree rotation about the x-axis (90 degree
	   clockwise) */
	glRotatef(-90.0, 1.0, 0.0, 0.0);
	/* translate 30 units along the y-axis */
	glTranslatef(0,30,0);
	/* -180 degree rotation about the x-axis (180 degree
	   clockwise) */
	glRotatef(-180.0,1.0,0.0,0.0);
	/* reduce the triangles size by 50% */
	glScalef(0.5,0.5,0.5);
	/* apply the above translations to the drawTriangle
	   function */
	drawTriangle();
}

/*
=================
display()
-Renders output to screen
=================
*/
void display(void)
{
	/* clear frame buffer and z-buffer */
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	/* move to the center of the screen */
	glLoadIdentity();
	
	/* call our triangle drawing function */
	constructTriangles();
	
	/* make sure all previously issued commands have
	   completed */
	glFlush();
	/* switch the back- and front-buffer and display the
	triangle */
	glutSwapBuffers();
}

void reshape(int w, int h)
{
	/* sets the viewport */
	glViewport(0, 0, (GLsizei) w, (GLsizei) h);
	
	/* sets the Projection matrix as the current matrix */
	glMatrixMode(GL_PROJECTION);
	/* move to the center of the screen */
	glLoadIdentity();
	
	/* initializes the perspective projection matrix */
	gluPerspective(45, (double)w / (double)h, 0.05, 100);
	
	/* sets the Modelview matrix as the current matrix */
	glMatrixMode(GL_MODELVIEW);
}

/*
=================
main
=================
*/
int main(int argc, char** argv)
{
	/* initialize the GLUT library. */
	glutInit(&argc, argv);
	/* sets the initial display mode:
	   double buffering and a depth buffer. */
	glutInitDisplayMode(GLUT_DOUBLE|GLUT_RGB|GLUT_DEPTH);
	/* sets default window size */
	glutInitWindowSize(800, 600);
	/* creates a top-level window with a caption */
	glutCreateWindow("OpenGL: Translation, Rotation, and Scaling");
	/* reshape callback */
	glutReshapeFunc(reshape);
	/* displays the triangle in the viewport */
	glutDisplayFunc(display);
	/* enables hidden-surface removal */
	glEnable(GL_DEPTH_TEST);
	/* the GLUT event processing loop */
	glutMainLoop();
	
	return 0;
}